diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericDoor.java
new file mode 100644
index 000000000..a9808ab37
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericDoor.java
@@ -0,0 +1,61 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicDoor;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericDoor<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel left;
+    public final @NotNull StaticBlockModel left_open;
+    public final @NotNull StaticBlockModel right;
+    public final @NotNull StaticBlockModel right_open;
+    public BlockModelGenericDoor(@NotNull Block<T> block, @NotNull String basekey, boolean bottom) {
+        super(block, BlockModelDispatcher.loadDataModel(basekey + "/" + (bottom ? "bottom" : "top") + "_left"));
+        String side = (bottom ? "bottom" : "top");
+        this.left = BlockModelDispatcher.loadDataModel("%s/%s_left".formatted(basekey, side)).asModel();
+        this.left_open = BlockModelDispatcher.loadDataModel("%s/%s_left_open".formatted(basekey, side)).asModel();
+        this.right = BlockModelDispatcher.loadDataModel("%s/%s_right".formatted(basekey, side)).asModel();
+        this.right_open = BlockModelDispatcher.loadDataModel("%s/%s_right_open".formatted(basekey, side)).asModel();
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        int data = worldSource.getBlockData(tilePos);
+        int rotation = data & BlockLogicDoor.MASK_ROTATION;
+        boolean isOpen = (data & BlockLogicDoor.MASK_OPENED) != 0;
+        if (isOpen) {
+            return switch (rotation) {
+                case 0 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+                case 1 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+                case 2 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+                default -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            };
+        } else {
+            return switch (rotation) {
+                case 0 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+                case 1 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+                case 2 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+                default -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            };
+        }
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        boolean isLeft = (data & BlockLogicDoor.MASK_HINGE) != 0;
+        boolean isOpen = (data & BlockLogicDoor.MASK_OPENED) != 0;
+        if (isLeft) {
+            return isOpen ? this.left_open : this.left;
+        } else {
+            return isOpen ? this.right : this.right_open;
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericDoorPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericDoorPainted.java
new file mode 100644
index 000000000..8bb49aab2
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericDoorPainted.java
@@ -0,0 +1,43 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicDoor;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericDoorPainted<T extends BlockLogic> extends BlockModelGenericDoor<T> {
+    public final @NotNull StaticBlockModel[] left = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public final @NotNull StaticBlockModel[] left_open = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public final @NotNull StaticBlockModel[] right = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public final @NotNull StaticBlockModel[] right_open = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public BlockModelGenericDoorPainted(@NotNull Block<T> block, boolean bottom) {
+        super(block, "minecraft:block/door/planks/white", bottom);
+        String side = (bottom ? "bottom" : "top");
+        for (DyeColor color : DyeColor.blockOrderedColors()) {
+            this.left[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/door/planks/%s/%s_left".formatted(color.colorID, side)).asModel();
+            this.left_open[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/door/planks/%s/%s_left_open".formatted(color.colorID, side)).asModel();
+            this.right[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/door/planks/%s/%s_right".formatted(color.colorID, side)).asModel();
+            this.right_open[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/door/planks/%s/%s_right_open".formatted(color.colorID, side)).asModel();
+        }
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        int color = (data >> 4) & DyeColor.MASK_COLOR;
+        boolean isLeft = (data & BlockLogicDoor.MASK_HINGE) != 0;
+        boolean isOpen = (data & BlockLogicDoor.MASK_OPENED) != 0;
+        if (isLeft) {
+            return isOpen ? this.left_open[color] : this.left[color];
+        } else {
+            return isOpen ? this.right[color] : this.right_open[color];
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFarmland.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFarmland.java
new file mode 100644
index 000000000..2b3617746
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFarmland.java
@@ -0,0 +1,39 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicFarmland;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericFarmland<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel dry_fertilized;
+    public final @NotNull StaticBlockModel wet;
+    public final @NotNull StaticBlockModel wet_fertilized;
+    public BlockModelGenericFarmland(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/farmland/dry"));
+        this.dry_fertilized = BlockModelDispatcher.loadDataModel("minecraft:block/farmland/dry_fertilized").asModel();
+        this.wet = BlockModelDispatcher.loadDataModel("minecraft:block/farmland/wet").asModel();
+        this.wet_fertilized = BlockModelDispatcher.loadDataModel("minecraft:block/farmland/wet_fertilized").asModel();
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        boolean isWet = BlockLogicFarmland.isWet(data);
+        boolean isFertilized = BlockLogicFarmland.isFertilized(data);
+        if (isWet) {
+            if (isFertilized) {
+                return this.wet_fertilized;
+            } else {
+                return this.wet;
+            }
+        } else {
+            if (isFertilized) {
+                return this.dry_fertilized;
+            } else {
+                return this.staticModel;
+            }
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFence.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFence.java
new file mode 100644
index 000000000..0e1728ea5
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFence.java
@@ -0,0 +1,50 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicAxisAligned;
+import net.minecraft.core.block.BlockLogicFence;
+import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericFence<T extends BlockLogicFence> extends BlockModelGeneric<T> {
+
+    public final @NotNull StaticBlockModel post;
+    public final @NotNull StaticBlockModel side;
+    public BlockModelGenericFence(@NotNull Block<T> block, @NotNull String basekey) {
+        super(block, BlockModelDispatcher.loadDataModel(basekey + "/inventory"));
+        this.post = BlockModelDispatcher.loadDataModel(basekey + "/post").asModel();
+        this.side = BlockModelDispatcher.loadDataModel(basekey + "/side").asModel();
+    }
+
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        boolean north = this.block.getLogic().canConnectTo(worldSource, tilePos, Side.NORTH);
+        boolean south = this.block.getLogic().canConnectTo(worldSource, tilePos, Side.SOUTH);
+        boolean west = this.block.getLogic().canConnectTo(worldSource, tilePos, Side.WEST);
+        boolean east = this.block.getLogic().canConnectTo(worldSource, tilePos, Side.EAST);
+        if (north) {
+            this.side.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+        }
+        if (west) {
+            this.side.renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+        }
+        if (south) {
+            this.side.renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+        }
+        if (east) {
+            this.side.renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+        }
+        return this.post.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFenceGate.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFenceGate.java
new file mode 100644
index 000000000..6e29de151
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFenceGate.java
@@ -0,0 +1,36 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicFenceGate;
+import net.minecraft.core.block.BlockLogicLever;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericFenceGate<T extends BlockLogic> extends BlockModelGeneric<T> {
+
+    public @NotNull StaticBlockModel open;
+    public BlockModelGenericFenceGate(@NotNull Block<T> block, @NotNull String baseKey) {
+        super(block, BlockModelDispatcher.loadDataModel(baseKey + "_closed"));
+        this.open = BlockModelDispatcher.loadDataModel(baseKey + "_open").asModel();
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        int data = worldSource.getBlockData(tilePos);
+        int rotation = data & BlockLogicFenceGate.MASK_DIRECTION;
+        return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, -rotation, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        boolean open = (data & BlockLogicFenceGate.MASK_OPEN) != 0;
+        return open ? this.open : this.staticModel;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFenceGatePainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFenceGatePainted.java
new file mode 100644
index 000000000..0d69469eb
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFenceGatePainted.java
@@ -0,0 +1,34 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicFenceGate;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericFenceGatePainted<T extends BlockLogic> extends BlockModelGenericFenceGate<T> {
+
+    public @NotNull StaticBlockModel[] open = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public @NotNull StaticBlockModel[] closed = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public BlockModelGenericFenceGatePainted(@NotNull Block<T> block) {
+        super(block, "minecraft:block/fencegate/white");
+        for (DyeColor color : DyeColor.blockOrderedColors()) {
+            this.closed[color.blockMeta] = BlockModelDispatcher.loadDataModel(String.format("minecraft:block/fencegate/%s_closed", color.colorID)).asModel();
+            this.open[color.blockMeta] = BlockModelDispatcher.loadDataModel(String.format("minecraft:block/fencegate/%s_open", color.colorID)).asModel();
+        }
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        int color = (data >> 4) & DyeColor.MASK_COLOR;
+        boolean open = (data & BlockLogicFenceGate.MASK_OPEN) != 0;
+        return open ? this.open[color] : this.closed[color];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFencePainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFencePainted.java
new file mode 100644
index 000000000..4b1bbeb22
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFencePainted.java
@@ -0,0 +1,60 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicAxisAligned;
+import net.minecraft.core.block.BlockLogicFence;
+import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericFencePainted<T extends BlockLogicFence> extends BlockModelGenericFence<T> {
+    public final @NotNull StaticBlockModel[] inventory = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public final @NotNull StaticBlockModel[] post = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public final @NotNull StaticBlockModel[] side = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public BlockModelGenericFencePainted(@NotNull Block<T> block) {
+        super(block, "minecraft:block/fence/white");
+        for (DyeColor color : DyeColor.blockOrderedColors()) {
+            this.inventory[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/fence/" + color.colorID + "/inventory").asModel();
+            this.post[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/fence/" + color.colorID + "/post").asModel();
+            this.side[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/fence/" + color.colorID + "/side").asModel();
+        }
+    }
+
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        int color = worldSource.getBlockData(tilePos) & DyeColor.MASK_COLOR;
+        boolean north = this.block.getLogic().canConnectTo(worldSource, tilePos, Side.NORTH);
+        boolean south = this.block.getLogic().canConnectTo(worldSource, tilePos, Side.SOUTH);
+        boolean west = this.block.getLogic().canConnectTo(worldSource, tilePos, Side.WEST);
+        boolean east = this.block.getLogic().canConnectTo(worldSource, tilePos, Side.EAST);
+        if (north) {
+            this.side[color].renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+        }
+        if (west) {
+            this.side[color].renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+        }
+        if (south) {
+            this.side[color].renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+        }
+        if (east) {
+            this.side[color].renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+        }
+        return this.post[color].renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return this.inventory[data & DyeColor.MASK_COLOR];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFenceThin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFenceThin.java
new file mode 100644
index 000000000..3ad86b001
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFenceThin.java
@@ -0,0 +1,80 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicFence;
+import net.minecraft.core.block.BlockLogicFenceThin;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericFenceThin<T extends BlockLogicFenceThin> extends BlockModelGeneric<T> {
+
+    public final @NotNull StaticBlockModel post;
+    public final @NotNull StaticBlockModel side;
+    public final @NotNull StaticBlockModel top;
+    public BlockModelGenericFenceThin(@NotNull Block<T> block, @NotNull String basekey) {
+        super(block, BlockModelDispatcher.loadDataModel(basekey + "/inventory"));
+        this.post = BlockModelDispatcher.loadDataModel(basekey + "/post").asModel();
+        this.side = BlockModelDispatcher.loadDataModel(basekey + "/side").asModel();
+        this.top = BlockModelDispatcher.loadDataModel(basekey + "/side_top").asModel();
+    }
+
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        boolean didRender = false;
+
+        TilePos queryPos = new TilePos();
+
+        boolean north = this.block.getLogic().canConnectTo(worldSource, tilePos, Side.NORTH);
+        boolean south = this.block.getLogic().canConnectTo(worldSource, tilePos, Side.SOUTH);
+        boolean west = this.block.getLogic().canConnectTo(worldSource, tilePos, Side.WEST);
+        boolean east = this.block.getLogic().canConnectTo(worldSource, tilePos, Side.EAST);
+
+        Block<?> blockAbove = worldSource.getBlock(tilePos.up(queryPos));
+        boolean upNorth = blockAbove == this.block && this.block.getLogic().canConnectTo(worldSource, tilePos.up(queryPos), Side.NORTH);
+        boolean upSouth = blockAbove == this.block && this.block.getLogic().canConnectTo(worldSource, tilePos.up(queryPos), Side.SOUTH);
+        boolean upWest = blockAbove == this.block && this.block.getLogic().canConnectTo(worldSource, tilePos.up(queryPos), Side.WEST);
+        boolean upEast = blockAbove == this.block && this.block.getLogic().canConnectTo(worldSource, tilePos.up(queryPos), Side.EAST);
+
+        if (north) {
+            if (upNorth) {
+                didRender |= this.side.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            } else {
+                didRender |= this.top.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+        }
+        if (west) {
+            if (upWest) {
+                didRender |= this.side.renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+            } else {
+                didRender |= this.top.renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+            }
+        }
+        if (south) {
+            if (upSouth) {
+                didRender |= this.side.renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+            } else {
+                didRender |= this.top.renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+            }
+        }
+        if (east) {
+            if (upEast) {
+                didRender |= this.side.renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+            } else {
+                didRender |= this.top.renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+            }
+        }
+        if (this.block.getLogic().shouldDrawColumn(worldSource, tilePos)) {
+            didRender |= this.post.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+        }
+        return didRender;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFlowerStackable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFlowerStackable.java
new file mode 100644
index 000000000..aed8ac346
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFlowerStackable.java
@@ -0,0 +1,30 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicFlowerStackable;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericFlowerStackable<T extends BlockLogicFlowerStackable> extends BlockModelGeneric<T> {
+    private final StaticBlockModel[] MODELS;
+
+    public BlockModelGenericFlowerStackable(@NotNull Block<T> block, @NotNull String baseModel) {
+        super(block, BlockModelDispatcher.loadDataModel(baseModel + 0));
+
+        this.MODELS = new StaticBlockModel[T.MAX_STACK_COUNT + 1];
+        for (int i = 0; i < T.MAX_STACK_COUNT + 1; i++) {
+            this.MODELS[i] = BlockModelDispatcher.loadDataModel(baseModel + i).asModel();
+        }
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        final int stackCount = T.getStackCount(data);
+        if (stackCount > T.MAX_STACK_COUNT) {
+            return this.MODELS[0];
+        }
+
+        return this.MODELS[stackCount];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFullyRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFullyRotatable.java
new file mode 100644
index 000000000..961b5c583
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFullyRotatable.java
@@ -0,0 +1,50 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicFullyRotatable;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericFullyRotatable<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public BlockModelGenericFullyRotatable(@NotNull Block<T> block, @NotNull StaticBlockModel staticModel) {
+        super(block, staticModel);
+    }
+
+    public BlockModelGenericFullyRotatable(@NotNull Block<T> block, @NotNull BlockModelData staticModel) {
+        super(block, staticModel);
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        final Direction dir = BlockLogicFullyRotatable.metaToDirection(worldSource.getBlockData(tilePos));
+        switch (dir) {
+            case UP -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case DOWN -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 2, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case NORTH -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, -1, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case SOUTH -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case WEST -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 1, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case EAST -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, -1, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+        }
+        return false;
+    }
+}
